/*
 * (./) ColorCellRenderer.java 05/12/27 by cs for "MMM" project
 * (cc) some right reserved
 */

package mmm.ui.manager;

import java.awt.Color;
import java.awt.Component;

import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.BorderFactory;
import javax.swing.table.TableCellRenderer;

import mmm.ui.TrackManager;

/* the color cell renderer
*/
public class ColorCellRenderer extends JLabel implements TableCellRenderer {
	
	static final String TIP = "change \"%s\" graphic color";
	
	/* return the new cell component
	 * @arg JTable, the current JTable
	 * @arg Object, the value of the cell to be rendered
	 * @arg boolean, is the cell selected
	 * @arg boolean, have the focus
	 * @arg int, the row index
	 * @ar int, the column index
	 */
	public Component getTableCellRendererComponent
		(JTable t, Object obj, boolean sel, boolean hF, int row, int col ) {
			
			String name	= t.getModel().getValueAt(row, 4).toString();
			Color bcol	= sel ? t.getSelectionBackground() :
				(( row%2!=0 ) ? TrackManager.ALTERNATE_BKG_COLOR :
								t.getBackground() );
			
			setOpaque( true );
			setEnabled( t.isEnabled() );
			setToolTipText( TIP.replaceAll("%s", name) );
			setBackground( (Color) obj );
			setBorder( BorderFactory.createLineBorder( bcol, 3) );
			
			// return componant
			return this;
		}
}
